###
### Account Services Manager - /etc/passwd Authentication Module
###

use vars qw($IsUnixPassword);
$IsUnixPassword = 1;

sub GetPassword
{
    my $User = shift;

    open(AUTH, $::Global_Config{'PasswdFile'}[1]);
    my @buffer = split("\n", join('', <AUTH>));
    close AUTH;

    my @tmp;

    foreach(@buffer) {
        @tmp = split(':', $_);
        return $tmp[1] if($tmp[0] eq $User);
    }

    &::FatalError("Unable to read encoded password from system passwd file.");
}

sub ChangePassword
{
    my $User = shift;
    my $new_passwd = crypt(shift, RandomSalt());

    system('/usr/sbin/usermod', '-p', $new_passwd, $User);
}

# This one's simple, we take a username and password and check it.
sub CheckPassword
{
    my($username, $password) = @_;

    return 0 unless(-e "$::BaseDir/users/$username");

    my $correct_passwd = GetPassword($username);
    if(crypt($password, $correct_passwd) eq $correct_passwd) {
        return 1;
    }
}

1;
