###
### HTML Library for the Account Services Manager
###
########################################################################
### This program is free software; you can redistribute it and/or
### modify it under the terms of the GNU General Public License
### as published by the Free Software Foundation; either version 2
### of the License, or (at your option) any later version.
###
### This program is distributed in the hope that it will be useful,
### but WITHOUT ANY WARRANTY; without even the implied warranty of
### MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
### GNU General Public License for more details.
###
### You should have received a copy of the GNU General Public License
### along with this program; if not, write to the Free Software
### Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
########################################################################

package HTML;

# Define the menu code variables here.
my $main_menu;
my $module_menu;

my $input, $buffer;

BEGIN
{
    open(THEME, "$ENV{'DOCUMENT_ROOT'}/themes/$::Global_Config{'CurrentTheme'}[1]/main_menu.html");
    $input = join('', <THEME>);
    close THEME;

    foreach(sort keys %::scripts)
    {
        $buffer =  $input;
        $buffer =~ s/<!-- Script Link -->/\/$::scripts{$_}/gi;
        $buffer =~ s/<!-- Script Name -->/$_/gi;
        $main_menu .= $buffer;
    }

    open(THEME, "$ENV{'DOCUMENT_ROOT'}/themes/$::Global_Config{'CurrentTheme'}[1]/module_menu.html");
    $input = join('', <THEME>);
    close THEME;

    foreach(sort keys %::modules)
    {
        $buffer =  $input;
        $buffer =~ s/<!-- Module Link -->/\/index.cgi?module=$_/gi;
        $buffer =~ s/<!-- Module Name -->/$::modules{$_}[1]/gi;
        $module_menu .= $buffer;
    }

    undef $input, $buffer;
}

sub PrintTop
{
    print "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n";

    open(THEME, "$ENV{'DOCUMENT_ROOT'}/themes/$::Global_Config{'CurrentTheme'}[1]/top.html") || &::FatalError("Cannot open top theme file: $!");
    my $output = join('', <THEME>);
    close THEME;

    my $version = &::GetVersion();
    $output =~ s/<!-- Module Title -->/$MODULE::Title/gi;
    $output =~ s/<!-- Module Header -->/$MODULE::Header/gi;
    $output =~ s/<!-- Registered Owner -->/$::Global_Config{'RegisteredOwner'}[1]/gi;
    $output =~ s/<!-- Registered URL -->/$::Global_Config{'RegisteredURL'}[1]/gi;
    $output =~ s/<!-- Username -->/$AUTH::User/gi;
    $output =~ s/<!-- Domain -->/$::UserConf{'Domain'}/gi;
    $output =~ s/<!-- ASM Version -->/$version/gi;
    $output =~ s/<!-- Main Menu -->/$main_menu/gi;
    $output =~ s/<!-- Module Menu -->/$module_menu/gi;

    my @lines = split("\n", $output);
    foreach(@lines) {
        if($_ =~ /^<!-- File (.*) -->$/) {
            my $filename = $1;
            unless(substr($file, 0, 1) eq '/' || substr($file, 0, 3) eq '../') {
                $filename = "$::BaseDir/$filename";
            }
            open(FILE, $filename);
            while(<FILE>) {
                print;
            }
            close FILE;
        }
        else {
            print $_;
        }
    }
}

sub PrintBottom
{
    open(THEME, "$ENV{'DOCUMENT_ROOT'}/themes/$::Global_Config{'CurrentTheme'}[1]/bottom.html") || &::FatalError("Cannot open bottom theme file: $!");
    my $output = join('', <THEME>);
    close THEME;

    my $version = &::GetVersion();
    $output =~ s/<!-- Module Title -->/$MODULE::Title/gi;
    $output =~ s/<!-- Module Header -->/$MODULE::Header/gi;
    $output =~ s/<!-- Registered Owner -->/$::Global_Config{'RegisteredOwner'}[1]/gi;
    $output =~ s/<!-- Registered URL -->/$::Global_Config{'RegisteredURL'}[1]/gi;
    $output =~ s/<!-- Username -->/$AUTH::User/gi;
    $output =~ s/<!-- Domain -->/$::UserConf{'Domain'}/gi;
    $output =~ s/<!-- ASM Version -->/$version/gi;
    $output =~ s/<!-- Main Menu -->/$main_menu/gi;
    $output =~ s/<!-- Module Menu -->/$module_menu/gi;

    my @lines = split("\n", $output);
    foreach(@lines) {
        if($_ =~ /^<!-- File (.*) -->$/) {
            my $filename = $1;
            unless(substr($file, 0, 1) eq '/' || substr($file, 0, 3) eq '../') {
                $filename = "$::BaseDir/$filename";            
            }
            open(FILE, $filename);
            while(<FILE>) {
                print;
            }
            close FILE;
        }
        else {
            print $_;
        }
    }
}

1;
