###
### Account Services Manager - Execute Shell Command
### ================================================
### By            : Brandon Ramirez
### Last Modified : 04/27/02
### Description   : Execute a shell command under a specific user's ID.
###

# This is essentially a miniature perl shell, except it executes on a
# command-by-command basis. It does NOT call the system shell at any time.

use POSIX ":sys_wait_h";

my $command, $path, @args;
my $background = 0;

sub gethostname
{
    my $hn = `/bin/hostname`;
    chop $hn;

    return $hn;
}

sub DisplayCommandPrompt
{
    my $hostname = gethostname();
    print qq~
    <form method="post" action="index.cgi" name="cmd">
    <h3 align="center"><u>Command Prompt</u></h3>
    <p align="center">
    <input type="hidden" name="module" value="exec-command">
    <font face="verdana, arial" size="2">[$AUTH::User\@$hostname \~]</font>
    <input type="text" name="command" value="" size="40" max="100"><br>
    Run in background: <input type="checkbox" name="background" value="yes"><br>
    <input type="submit" value="Run Command">
    </p>
    </form>
    <script language="JavaScript" type="text/javascript">window.document.cmd.command.focus();</script>~;
}

sub ParseCommand
{
    # Remove any beginning or trailing whitespace.
    $command =~ s/^\s*\t*\s*//g;
    $command =~ s/\s*\t*\s*$//g;

    # Do we launch it in the background?
    $background = 1 if($command =~ s/\s?&$//);

    @args = split(/\s/, $command);    # This hokis-pokis regex is so that a \ before a space keeps it as part of an arg.
    $path = $args[0];
    shift @args;
}

sub FindExecPath
{
    my $path_1 = substr($path, 0, 1);
    if($path_1 ne '/' && $path_1 ne '.') {
        $ENV{'PATH'} = $Global_Config{'ExecPath'}[1];
        $path = API::which($path) . "/$path";
    }
}

sub ExecCommand
{
    return if(!$path);

    my $pid = fork();
    if($pid) {
        # If this is a background process, keep doing what we normally do, otherwise wait for the process to finish.
        unless($background) {
            do {
                $status = waitpid($pid, &WNOHANG);
            } until $status == $pid;
        }
    }
    else {
        open(STDERR, "<&=1");
        my @pwd = getpwnam($AUTH::User);
        if($pwd[3]) {
            chdir($UserConf{'Home'});
            $( = $pwd[3];
            $) = $pwd[3];
            $< = $pwd[2];
            $> = $pwd[2];
            exec($path, @args);
            exit;
        }
        else {
            print "<b>SECURITY FAILURE:</b> Unable to find user id of non-super user $AUTH::User in passwd database!\n";
        }
    }
}

sub Main
{
    if(exists $HTTP_Args{'command'})
    {
        $command = $HTTP_Args{'command'};
        $background = 1 if($HTTP_Args{'background'} eq 'yes');
        ParseCommand();
        FindExecPath();
        print "<pre>\n";
        ExecCommand();
        print "</pre>\n";
    }

    DisplayCommandPrompt();
}

1;
