###
### Protected Directories module
###

### Read config ###
my($htaccess, $htpasswd) = ($Global_Config{'AccessFileName'}[1], $Global_Config{'HtpasswdFileName'}[1]);

# How many users can we show on a page at a time?
my $MAX_ACCOUNTS_PER_PAGE = 5;

# Global variables we'll always need access to.
my $current_uid, $directory, $path, $htpasswd_path, $realm;

# Get a list of all subdirectories of the user's home directory.
my @directories = API::RecursiveList($UserConf{'Home'});

# Switch to the user's id. Backup the current uid first.
sub ChangeUserID
{
    $current_uid = $<;
    $< = (getpwnam($AUTH::User))[2];
}

# Create a dropdown menu of everything in @directories.
sub ListDirectories
{
    print "<select name=\"directory\">\n";

    foreach(sort @directories)
    {
        print "<option value=\"$_\">$_</option>\n";
    }

    print "</select>\n";
}

### HTML Form Sub-Routines ###

sub PrintConfigureForm
{
    my $htpasswd_buff, $action;
    $htpasswd_buff = $htpasswd_path if($HTTP_Args{'action'} eq 'update');

    print "<form method=\"post\" action=\"$ENV{'SCRIPT_NAME'}\">\n";
    print "<input type=\"hidden\" name=\"module\" value=\"htpasswd\">\n";
    print "<input type=\"hidden\" name=\"directory\" value=\"$directory\">\n";
    print "<input type=\"hidden\" name=\"action\" value=\"configure\">\n";
    print "<table border=\"0\" cellpadding=\"1\" cellspacing=\"1\" align=\"center\">\n";
    print " <tr>\n";
    print "  <td align=\"center\" colspan=\"2\"><font face=\"verdana, arial\"><u>Configure Directory</u></font></td>\n";
    print " </tr>\n";
    print " <tr>\n";
    print "  <td><font face=\"verdana, arial\" size=\"2\">Realm:</font></td>\n";
    print "  <td><input type=\"text\" name=\"Realm\" value=\"$realm\"></td>\n";
    print " </tr>\n";
    print " <tr>\n";
    print "  <td><font face=\"verdana, arial\" size=\"2\">Password file (for advanced users):</font></td>\n";
    print "  <td><input type=\"text\" name=\"htpasswd\" value=\"$htpasswd_buff\"></td>\n";
    print " </tr>\n";
    print " <tr>\n";
    print "  <td colspan=\"2\" align=\"center\"><input type=\"submit\" value=\"Configure\"></td>\n";
    print " </tr>\n";
    print "</table>\n";
    print "</form>";
}

sub PrintAddUserForm
{
    print "<p align=\"center\">\n"; 
    print "<form method=\"post\" action=\"$ENV{'SCRIPT_NAME'}\">\n";
    print "<input type=\"hidden\" name=\"module\" value=\"htpasswd\">\n";
    print "<input type=\"hidden\" name=\"directory\" value=\"$directory\">\n";
    print "<input type=\"hidden\" name=\"action\" value=\"adduser\">\n";
    print "<input type=\"hidden\" name=\"offset\" value=\"$offset\">\n" if(exists $HTTP_Args{'offset'});
    print "<table border=\"0\" cellpadding=\"0\" cellspacing=\"1\" align=\"center\">\n";
    print " <tr>\n";
    print "  <td colspan=\"2\" align=\"center\"><h2><u>Add User</u></h2></td>\n";
    print " </tr>\n";
    print " <tr>\n";
    print "  <td><font face=\"verdana, arial\" size=\"2\">Username:</font></td>\n";
    print "  <td><input type=\"text\" name=\"user\" value=\"\">\n";
    print " </tr>\n";
    print " <tr>\n";
    print "  <td><font face=\"verdana, arial\" size=\"2\">Password:</font></td>\n";
    print "  <td><input type=\"password\" name=\"pass\" value=\"\">\n";
    print " </tr>\n";
    print " <tr>\n";
    print "  <td colspan=\"2\" align=\"center\"><input type=\"submit\" value=\"Add User\"></td>\n";
    print " </tr>\n";
    print "</table>\n";
    print "</form>\n";
}

sub PrintChangePasswordForm
{
    print "<form method=\"post\" action=\"$ENV{'SCRIPT_NAME'}\">\n";
    print "<input type=\"hidden\" name=\"module\" value=\"htpasswd\">\n";
    print "<input type=\"hidden\" name=\"directory\" value=\"$directory\">\n";
    print "<input type=\"hidden\" name=\"action\" value=\"change\">\n";
    print "<input type=\"hidden\" name=\"user\" value=\"$HTTP_Args{'user'}\">\n";
    print "<input type=\"hidden\" name=\"offset\" value=\"$offset\">\n" if(exists $HTTP_Args{'offset'});
    print "<table border=\"0\" cellpadding=\"1\" cellspacing=\"1\" align=\"center\">\n";
    print " <tr>\n";
    print "  <td align=\"center\" colspan=\"2\"><font face=\"verdana, arial\"><u>Change Password</u><br><font size=\"2\">User: $HTTP_Args{'user'}</font></font></td>\n";
    print " </tr>\n";
    print " <tr>\n";
    print "  <td><font face=\"verdana, arial\" size=\"2\">New Password:</font></td>\n";
    print "  <td><input type=\"password\" name=\"pass\" value=\"\">\n";
    print " </tr>\n";
    print " <tr>\n";
    print "  <td colspan=\"2\" align=\"center\"><input type=\"submit\" value=\"Submit Changes\"></td>\n";
    print " </tr>\n";
    print "</table>\n";
    print "</form>\n";
}

### Main function ###
sub Main
{
    $directory = $HTTP_Args{'directory'};

    if($directory)
    {
        ChangeUserID();

        if(!-e "$UserConf{'Home'}/$directory") {
            print "<font face=\"verdana, arial\" size=\"2\">Error: Directory $directory not found!</font>";
            $< = $current_uid;    # Change back to the asm user.
            return;
        }

        $path = $UserConf{'Home'} . '/' . $directory;

        my $configured = 0;

        # Get the path to the htpasswd file.
        $htpasswd_path = "$path/$htpasswd";
        $realm = 'Protected Area';
        open(ACCESS, "$path/$htaccess");
        while(<ACCESS>) {
            if($_ =~ /^AuthUserFile /) {
                $htpasswd_path = (split(/\s/))[1];
                $htpasswd_path =~ s/\n\r?$//;
                $htpasswd_path = $1 if($htpasswd_path =~ /^([^>]*)$/);
            }elsif($_ =~ /^AuthName /) {
                my @tmp = split(/\s/);
                shift @tmp;
                $realm = join(' ', @tmp);
                $realm =~ s/\n\r?$//;
                $realm =~ s/^'//;
                $realm =~ s/'$//;
            }elsif($_ =~ /^require valid-user\n?$/) {
                $configured = 1;
            }
        }
        close ACCESS;

        if((!$configured) && $HTTP_Args{'action'} ne 'configure') {
            PrintConfigureForm();
            $< = $current_uid;
            return;
        }

        if($HTTP_Args{'action'} eq 'configure') {
            open(ACCESS, ">$path/$htaccess");
            if($HTTP_Args{'htpasswd'}) {
                print ACCESS "AuthUserFile $HTTP_Args{'htpasswd'}\n";
            }else{
                print ACCESS "AuthUserFile $path/$htpasswd\n";
            }
            print ACCESS "AuthName '$HTTP_Args{'Realm'}'\n";
            print ACCESS "AuthType Basic\n";
            print ACCESS "require valid-user";
            close ACCESS;
            my $targethtpasswd;
            if($HTTP_Args{'htpasswd'}) {
                $targethtpasswd = $HTTP_Args{'htpasswd'};
            }else{
                $targethtpasswd = "$path/$htpasswd";
            }
            unless(-e $targethtpasswd) {
                open(PASSWD, ">$targethtpasswd");
                close PASSWD;
            }
            $realm = $HTTP_Args{'Realm'};
            print "<font face=\"verdana, arial\" size=\"2\">$path is now correctly configured for password-protection.</font>\n";
        }elsif($HTTP_Args{'action'} eq 'adduser') {
            my($user, $pass) = ($HTTP_Args{'user'}, $HTTP_Args{'pass'});
            if(!$user) {
                PrintAddUserForm();
                $< = $current_uid;
                return;
            }
            open(PASSWD, ">>$htpasswd_path");
            print PASSWD "$user:" . crypt($pass, API::RandomSalt()) . "\n";
            close PASSWD;
            print "<font face=\"verdana, arial\" size=\"2\">User $user added successfully.</font>\n";
        }elsif($HTTP_Args{'action'} eq 'change') {{
            my($user, $pass) = ($HTTP_Args{'user'}, $HTTP_Args{'pass'});
            if(!$user) {
                print "<font face=\"verdana, arial\" size=\"2\">Error: You must supply a username to edit.</font>\n";
                last;
            }
            if(!$pass) {
                PrintChangePasswordForm();
                $< = $current_uid;
                return;
            }

            my $buffer;
            my $user_found = 0;
            open(PASSWD, $htpasswd_path);
            while(<PASSWD>)
            {
                if($_ =~ /^$user:/) {
                    $user_found = 1;
                    $buffer .= "$user:" . crypt($pass, API::RandomSalt()) . "\n";
                }else{
                    $buffer .= $_;
                }
            }
            close PASSWD;

            if($user_found) {
                open(PASSWD, ">$htpasswd_path");
                print PASSWD $buffer;
                close PASSWD;
                print "<font face=\"verdana, arial\" size=\"2\">Password for $user changed successfully.</font>\n";
            }else{
                print "<font face=\"verdana, arial\" size=\"2\">Error: $user was not found in htpasswd file!</font>\n";
                undef $buffer;                
            }
        }}elsif($HTTP_Args{'action'} eq 'delete') {{
            my $user = $HTTP_Args{'user'};
            if(!$user) {
                print "<font face=\"verdana, arial\" size=\"2\">Error: You must supply a username to delete.</font>\n";
                last;
            }

            my $buffer;
            my $user_found = 0;
            open(PASSWD, $htpasswd_path);
            while(<PASSWD>)
            {
                if($_ =~ /^$user:/) {
                    $user_found = 1;
                }else{
                    $buffer .= $_;
                }
            }
            close PASSWD;

            if($user_found) {
                open(PASSWD, ">$htpasswd_path");
                print PASSWD $buffer;
                close PASSWD;
                print "<font face=\"verdana, arial\" size=\"2\">$user successfully deleted.</font>\n";
            }else{
                print "<font face=\"verdana, arial\" size=\"2\">Error: $user was not found in htpasswd file!</font>\n";
                undef $buffer;
            }
        }}elsif($HTTP_Args{'action'} eq 'update') {
            PrintConfigureForm();
            $< = $current_uid;
            return;
        }

        my $NumberOfAccounts, $NumberShown, $offset = 0;
        $offset = $HTTP_Args{'offset'} if(exists $HTTP_Args{'offset'});
        print "<table border=\"1\" cellpadding=\"0\" cellspacing=\"0\" width=\"500\" align=\"center\">\n";
        print " <tr>\n";
        print "  <td colspan=\"3\" align=\"center\"><h2><u><a href=\"index.cgi?module=htpasswd&directory=$directory&action=update&offset=$offset\" class=\"nohighlight\">$realm</a></u></h2></td>\n";
        print " </tr>\n";
        print " <tr>\n";
        print "  <td><u><font face=\"verdana, arial\" size=\"2\">Username</font></u></td>\n";
        print "  <td><u><font face=\"verdana, arial\" size=\"2\">Change password</font></u></td>\n";
        print "  <td><u><font face=\"verdana, arial\" size=\"2\">Delete</font></u></td>\n";
        print " </tr>\n";
        open(PASSWD, $htpasswd_path);
        my @users = <PASSWD>;
        my $user;
        foreach my $line(sort @users) {
            if($NumberOfAccounts >= $offset && $NumberOfAccounts < $offset + $MAX_ACCOUNTS_PER_PAGE){
                $user = (split(/:/, $line))[0];
                $user =~ s/\n$//;
                print " <tr>\n";
                print "  <td><font face=\"verdana, arial\" size=\"2\">$user</font></td>\n";
                print "  <td><a href=\"index.cgi?module=htpasswd&directory=$directory&action=change&user=$user&offset=$offset\"><img src=\"/themes/$Global_Config{'CurrentTheme'}[1]/button.gif\" border=\"0\"></a></td>\n";
                print "  <td><a href=\"index.cgi?module=htpasswd&directory=$directory&action=delete&user=$user&offset=$offset\"><img src=\"/themes/$Global_Config{'CurrentTheme'}[1]/button.gif\" border=\"0\"></a></td>\n";
                print " </tr>\n";
                $NumberShown++;
            }
            $NumberOfAccounts++;
        }
        close PASSWD;
        if($NumberOfAccounts)
        {
            my $num1 = $offset + 1;
            my $num2 = $offset + $MAX_ACCOUNTS_PER_PAGE;
            $num2    = $num2 - ($num2 - $NumberOfAccounts) if($num2 > $NumberOfAccounts);
            print "  <td colspan=\"5\" align=\"center\"><font face=\"verdana, arial\" size=\"2\">$NumberOfAccounts user(s) found, $num1 through $num2 displayed.</font></td>\n";
            print " </tr>\n";
            print " <tr>\n";
            my $previous = $offset - $MAX_ACCOUNTS_PER_PAGE;
            my $next     = $offset + $MAX_ACCOUNTS_PER_PAGE;
            print "  <td colspan=\"5\" align=\"center\">\n";
            print "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"100%\">\n";
            print " <tr>\n";
            my $prev, $forw;
            if($previous < 0){
                $prev = "<font color=\"gray\">&lt;&lt;Previous</font>";
            }else{
                $prev = "<a href=\"index.cgi?module=htpasswd&directory=$directory&offset=$previous\">&lt;&lt;Previous</a>";
            }
            print "  <td><font face=\"verdana, arial\" size=\"2\">$prev</font></td>\n";
            if($next >= $NumberOfAccounts){
                $forw = "<font color=\"gray\">Next>></font>";
            }else{
                $forw = "<a href=\"index.cgi?module=htpasswd&directory=$directory&offset=$next\">Next>></a>";
            }
            print "  <td><font face=\"verdana, arial\" size=\"2\">$forw</font></td>\n";
            print " </tr>\n";
            print "</table>\n";
            print "  </td>\n";
        }else
        {
            print "  <td colspan=\"5\" align=\"center\"><font face=\"verdana, arial\" size=\"2\">No users were found for realm $realm.</font></td>\n";
        }
        print "</table>\n\n";

        print "<p align=\"center\"><font face=\"verdana, arial\" size=\"2\"><b>Options:</b>&nbsp;<a href=\"index.cgi?module=htpasswd&directory=$directory&action=adduser&offset=$offset\">Add User</a> \| <a href=\"index.cgi?module=htpasswd&directory=$directory\">Refresh List</a></font></p>\n";

        $< = $current_uid;    # Change back to the dam user.
    }else
    {
        print "<font face=\"verdana, arial\" size=\"2\">Select a directory to manage:\n";
        print "<form method=\"get\" action=\"$ENV{'SCRIPT_NAME'}\">\n";
        print "<input type=\"hidden\" name=\"module\" value=\"htpasswd\">\n";
        ListDirectories();
        print "<input type=\"submit\" value=\"Go!\">\n";
        print "</form>\n</font>\n";
    }
}

1;
