#!/usr/bin/perl

###
### Subdomain Reloader
### ==================
### By            : Brandon Ramirez
### Date          : Wednesday, March 20, 2002
### Last Modified : Thursday, April 25, 2002
### Email         : brandonramirez@users.sourceforge.net
###

###
### Configuration
###
my $MINUTES_TO_SLEEP = 5;
my $LOG_FILE         = '/usr/local/asm/logs/srd.log';
my $CONFIG_FILE      = '/usr/local/apache/conf/vhosts.conf';

###
### Load everything we need.
###
$home = '/usr/local/asm';
require "$home/lib/main.pl";

my($main_buffer, $date, @directives, $main_last_mod, $main_last_mod_fs);

###
### Put this program into the background.
###
if($ARGV[0] ne '--nodaemon')
{
    print "Starting Subdomain Reloader...\n";
    fork() && exit(0);
    open(STDIN,  "/dev/null");
    open(STDOUT, ">$LOG_FILE");
    open(STDERR, ">>$LOG_FILE");
}

###
### Program Loop
###
while(1)
{
    ###
    ### Load the cached data from our last time through this loop.
    ###
    open(CACHE, "$home/modules/subdomains/cache");
    $main_last_mod = <CACHE>;
    chop $main_last_mod;
    $table_last_mod = <CACHE>;
    if($table_last_mod =~ /\n$/) {
        chop $table_last_mod;
    }
    close CACHE;

    ###
    ### Get the main configuration text.
    ###
    $main_last_mod_fs = (stat($CONFIG_FILE))[9];
    if($main_last_mod_fs > $main_last_mod)
    {
        system('/usr/bin/killall', '-USR1', 'httpd');

        ###
        ### Update the cache.
        ###
        open(CACHE, ">$home/modules/subdomains/cache");
        print CACHE "$main_last_mod_fs\n";
        close CACHE;
    }

    ###
    ### Take a little break =)
    ###
    if($ARGV[0] ne '--nodaemon')
    {
        sleep($MINUTES_TO_SLEEP * 60);
    }
    else
    {
        exit(0);
    }
}
