#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>

/*
 * Note: The functions below were borrowed from the shadow library.
 * The first one is Copyright 1989 - 1992, Julianne Frances Haugh.
 * I believe the second one was written by Marek Michalkiewicz.
 */

/*
 * i64c - convert an integer to a radix 64 character
 */

int
i64c(int i)
{
	if (i <= 0)
		return ('.');

	if (i == 1)
		return ('/');

	if (i >= 2 && i < 12)
		return ('0' - 2 + i);

	if (i >= 12 && i < 38)
		return ('A' - 12 + i);

	if (i >= 38 && i < 63)
		return ('a' - 38 + i);

	return ('z');
}

/*
 * This is the old style random salt generator...
 */
char *
crypt_make_salt(void)
{
	time_t now;
	static unsigned long x;
	static char result[3];

	time(&now);
	x += now + getpid() + clock();
	result[0] = i64c(((x >> 18) ^ (x >> 6)) & 077);
	result[1] = i64c(((x >> 12) ^ x) & 077);
	result[2] = '\0';
	return result;
}
